/**

 * responsiveMenu
 * headerFixed
 * searchButton
 * slideTeam
 * slideBrand
 * slideTestimonial
 * slideTeam_v2
 * slideTestimonial_v2
 * accordionToggle
 * portfolioIsotope
 * ajaxContactForm
 * counterAbout
 * progressBar
 * detectViewport
 * parallax
 * swClick
 * googleMap
 * popupGallery
 * goTop
 * retinaLogos
 * removePreloader

*/

;(function($) {

   'use strict'
        var isMobile = {
            Android: function() {
                return navigator.userAgent.match(/Android/i);
            },
            BlackBerry: function() {
                return navigator.userAgent.match(/BlackBerry/i);
            },
            iOS: function() {
                return navigator.userAgent.match(/iPhone|iPad|iPod/i);
            },
            Opera: function() {
                return navigator.userAgent.match(/Opera Mini/i);
            },
            Windows: function() {
                return navigator.userAgent.match(/IEMobile/i);
            },
            any: function() {
                return (isMobile.Android() || isMobile.BlackBerry() || isMobile.iOS() || isMobile.Opera() || isMobile.Windows());
            }
        }; // is Mobile
        
        var responsiveMenu = function() {
            var menuType = 'desktop';

            $(window).on('load resize', function() {
                var currMenuType = 'desktop';

                if ( matchMedia( 'only screen and (max-width: 991px)' ).matches ) {
                    currMenuType = 'mobile';
                }

                if ( currMenuType !== menuType ) {
                    menuType = currMenuType;

                    if ( currMenuType === 'mobile' ) {
                        var $mobileMenu = $('#mainnav').attr('id', 'mainnav-mobi').hide();
                        var hasChildMenu = $('#mainnav-mobi').children('ul').children('li');
                        var hasChildMenuMega = $('#mainnav-mobi').children('ul').children('li');

                        $('#header').after($mobileMenu);
                        hasChildMenu.children('ul').hide();
                        //hasChildMenu.children('a').after('<span class="btn-submenu"></span>'); // GA Removed
                        hasChildMenuMega.children('.sub-menu').hide();						
                        $('ul.submenu-child').hide();
                        hasChildMenuMega.children('ul.sub-menu').children('li.has-submenu-child').append('<span class="btn-submenu-child"></span>');
                        $('.btn-menu').removeClass('active');

                    } else {
                        var $desktopMenu = $('#mainnav-mobi').attr('id', 'mainnav').removeAttr('style');
                        $desktopMenu.find('.sub-menu').removeAttr('style');
                        $('#header').find('.nav-wrap').append($desktopMenu);
                        $('.btn-submenu').remove();
                        $('.btn-submenu-child').remove();
                        $('ul.submenu-child').show();
                        $('h3').children('span').removeClass('btn-submenu-child');
                    }
                }
            });

            $('.btn-menu').on('click', function() {         
                $('#mainnav-mobi').slideToggle(300);
                $(this).toggleClass('active');
                return false;
            });

            $(document).on('click', '.btn-submenu-child', function(e) {
                $(this).toggleClass('active').parent('li').children('.submenu-child').slideToggle(400);
                e.stopImmediatePropagation();
                return false;
            });

            $(document).on('click', '#mainnav-mobi li .btn-submenu', function(e) {
                $(this).toggleClass('active').next('.sub-menu').slideToggle(400);
                e.stopImmediatePropagation();
                return false;
            });
        }; // Responsive Menu       

        var headerFixed = function() {
            if ( $('body').hasClass('header_sticky') ) {
                var nav = $('.header');
                if ( nav.size() != 0 ) {
                    
                    var offsetTop = $('.header').offset().top,
                        headerHeight = $('.header').height(),
                        injectSpace = $('<div />', { height: headerHeight }).insertAfter(nav);   
                        injectSpace.hide();                 

                    $(window).on('load scroll', function(){
                        if ( $(window).scrollTop() > offsetTop + 100 ) {
                            injectSpace.hide(); // （GA - .show ⇒　.hideに変更）
                            $('.header').addClass('downscrolled');
                            
                        } else {
                            $('.header').removeClass('downscrolled');
                            injectSpace.hide();
                        }

                        if ( $(window).scrollTop() > 600) {
                            $('.header').addClass('upscrolled');
                        } else {
                            $('.header').removeClass('upscrolled');
                        }
                    })
                }
            }
        }; // Header Fixed

        var searchButton = function() {
            var showsearch = $('.show-search button');
            showsearch.on('click',function() {
                $('.show-search .top-search').toggleClass('active');
                showsearch.toggleClass('active');
            });
        }; // Show Search Button

        var slideTeam = function() {
            $(".owl-carousel").owlCarousel({
                autoplay:true,
                dots:false,
                nav: true,
                margin:10,
                loop:true,
                items:4,
                responsive:{
                    0:{
                        items: 1
                    },

                    479:{
                        items: 2
                    },
                    768:{
                        items: 3
                    },
                    991:{
                        items: 4
                    },
                    1200: {
                        items: 4
                    }
                }
            });
        };// slide Team

        var slideBrand = function() {
            $(".owl-carousel-1").owlCarousel({
                autoplay:true,
                dots:false,
                margin:30,
                loop:true,
                items:5,
                responsive:{
                    0:{
                        items: 2
                    },

                    479:{
                        items: 3
                    },
                    768:{
                        items: 3
                    },
                    991:{
                        items: 4
                    },
                    1200: {
                        items: 5,
                        nav: true
                    }
                }
            });
        };// slide Brand

        var slideTestimonial = function() {
            $(".owl-carousel-2").owlCarousel({
                autoplay:true,
                nav: false,
                responsive: true,
                margin: 15,
                loop:true,
                items:2,
                responsive:{
                    0:{
                        items: 1
                    },

                    479:{
                        items: 1
                    },
                    768:{
                        items: 1
                    },
                    991:{
                        items: 1
                    },
                    1200: {
                        items: 2
                    }
                }
            });
        };// slide Testimonial

        var slideTeam_v2 = function() {
            $(".owl-carousel-3").owlCarousel({
                autoplay:true,
                dots:false,
                nav: false,
                loop:true,
                items:4,
                responsive:{
                    0:{
                        items: 1
                    },

                    479:{
                        items: 2,
                        margin:20
                    },
                    768:{
                        items: 3,
                        margin:20
                    },
                    991:{
                        items: 3,
                        margin:20
                    },
                    1200: {
                        items: 4,
                        margin:30
                    }
                }
            });
        };// slide Team V2

        var slideTestimonial_v2 = function() {
            $(".owl-carousel-4").owlCarousel({
                autoplay:true,
                dots:true,
                nav: false,
                loop:true,
                items:1,
                margin: 10,
                responsive:{
                    0:{
                        dots:false,
                    },

                    479:{
                        dots:false,
                    },
                    768:{
                        dots:false,
                    },
                    991:{
                        dots:false,
                    },
                    1200: {
                        dots:true,
                    }
                }
            });
        };// slide Testimonial V2

        var accordionToggle = function() {
            var speed = {duration: 400};
            $('.toggle-content').hide();
            $('.accordion-toggle .toggle-title.active').siblings('.toggle-content').show();
            $('.accordion').find('.toggle-title').on('click', function() {
                $(this).toggleClass('active');
                $(this).next().slideToggle(speed);
                $(".toggle-content").not($(this).next()).slideUp(speed);
                if ($(this).is('.active')) {
                    $(this).closest('.accordion').find('.toggle-title.active').toggleClass('active')
                    $(this).toggleClass('active');
                };
            });
        }; // Accordion Toggle

        var portfolioIsotope = function() { 
            if ( $().isotope ) {           
                var $container = $('.portfolio-list');
                $container.imagesLoaded(function(){
                    $container.isotope({
                        itemSelector: '.ipsotope',
                        transitionDuration: '1s'
                    });
                });

                $('.menu-tab li').on('click',function() {                           
                    var selector = $(this).attr('data-filter');
                    $('.menu-tab li').removeClass('active');
                    $(this).addClass('active');
                    $container.isotope({ filter: selector });
                    return false;
                });            
            };
        }; // Portfolio Isotope

        var counterAbout = function() {      
            if ( $().countTo ) {
                $('.wrap-counter').on('on-appear', function() {
                    $(this).find('.numb-count').each(function() {
                        var to = parseInt( $(this).data('to'), 10 ),
                            speed = parseInt( $(this).data('speed'), 10 );
                            
                        $(this).countTo({
                            to: to,
                            speen: speed
                        });
                    });
                }); // wrap counter
            };
        }; // Counter About

        var progressBar = function() {        
            $('.progres-bar').on('on-appear', function() {
                $(this).each(function() {
                    $(this).css("overflow", "inherit");
                    var percent = $(this).data('percent');                
                    $(this).find('.progress-animate').animate({
                        "overflow":"inherit",
                        "width": percent + '%'
                    }, $(this).find('.progress-animate').data('duration') );

                    $(this).parent('.progress-item').find('.perc').addClass('show').animate({
                        "overflow":"inherit",
                        "width": percent + '%'
                    }, $(this).find('.progress-animate').data('duration') );
                });
            });
        }; // Progress Bar

        var detectViewport = function() {
            $('[data-waypoint-active="yes"]').waypoint(function() {
                $(this).trigger('on-appear');
            }, { offset: '90%', triggerOnce: true });
             $(window).on('load', function() {
                setTimeout(function() {
                    $.waypoints('refresh');
                }, 100);
            });
        }; // Detect Viewport

        var parallax = function() {
            if ( $().parallax && isMobile.any() == null ) {
                $('.parallax1').parallax("50%", 0.3);
                $('.parallax2').parallax("50%", 0.3);
            }
        }; // Parallax

        var ajaxSubscribe = {
            obj: {
                subscribeEmail    : $('#subscribe-email'),
                subscribeButton   : $('#subscribe-button'),
                subscribeMsg      : $('#subscribe-msg'),
                subscribeContent  : $("#subscribe-content"),
                dataMailchimp     : $('#subscribe-form').attr('data-mailchimp'),
                success_message   : '<div class="notification_ok">Thank you for joining our mailing list! Please check your email for a confirmation link.</div>',
                failure_message   : '<div class="notification_error">Error! <strong>There was a problem processing your submission.</strong></div>',
                noticeError       : '<div class="notification_error">{msg}</div>',
                noticeInfo        : '<div class="notification_error">{msg}</div>',
                basicAction       : 'mail/subscribe.php',
                mailChimpAction   : 'mail/subscribe-mailchimp.php'
            },

            eventLoad: function() {
                var objUse = ajaxSubscribe.obj;

                $(objUse.subscribeButton).on('click', function() {
                    if ( window.ajaxCalling ) return;
                    var isMailchimp = objUse.dataMailchimp === 'true';

                    if ( isMailchimp ) {
                        ajaxSubscribe.ajaxCall(objUse.mailChimpAction);
                    } else {
                        ajaxSubscribe.ajaxCall(objUse.basicAction);
                    }
                });
            },

            ajaxCall: function (action) {
                window.ajaxCalling = true;
                var objUse = ajaxSubscribe.obj;
                var messageDiv = objUse.subscribeMsg.html('').hide();
                $.ajax({
                    url: action,
                    type: 'POST',
                    dataType: 'json',
                    data: {
                       subscribeEmail: objUse.subscribeEmail.val()
                    },
                    success: function (responseData, textStatus, jqXHR) {
                        if ( responseData.status ) {
                            objUse.subscribeContent.fadeOut(500, function () {
                                messageDiv.html(objUse.success_message).fadeIn(500);
                            });
                        } else {
                            switch (responseData.msg) {
                                case "email-required":
                                    messageDiv.html(objUse.noticeError.replace('{msg}','Error! <strong>Email is required.</strong>'));
                                    break;
                                case "email-err":
                                    messageDiv.html(objUse.noticeError.replace('{msg}','Error! <strong>Email invalid.</strong>'));
                                    break;
                                case "duplicate":
                                    messageDiv.html(objUse.noticeError.replace('{msg}','Error! <strong>Email is duplicate.</strong>'));
                                    break;
                                case "filewrite":
                                    messageDiv.html(objUse.noticeInfo.replace('{msg}','Error! <strong>Mail list file is open.</strong>'));
                                    break;
                                case "undefined":
                                    messageDiv.html(objUse.noticeInfo.replace('{msg}','Error! <strong>undefined error.</strong>'));
                                    break;
                                case "api-error":
                                    objUse.subscribeContent.fadeOut(500, function () {
                                        messageDiv.html(objUse.failure_message);
                                    });
                            }
                            messageDiv.fadeIn(500);
                        }
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        alert('Connection error');
                    },
                    complete: function (data) {
                        window.ajaxCalling = false;
                    }
                });
            }
        };

        var ajaxContactForm = function() {  
            $('#contactform').each(function() {
                $(this).validate({
                    submitHandler: function( form ) {
                        var $form = $(form),
                            str = $form.serialize(),
                            loading = $('<div />', { 'class': 'loading' });

                        $.ajax({
                            type: "POST",
                            url:  $form.attr('action'),
                            data: str,
                            beforeSend: function () {
                                $form.find('.form-submit').append(loading);
                            },
                            success: function( msg ) {
                                var result, cls;                            
                                if ( msg == 'Success' ) {                                
                                    result = 'Message Sent Successfully To Email Administrator. ( You can change the email management a very easy way to get the message of customers in the user manual )';
                                    cls = 'msg-success';
                                } else {
                                    result = 'Error sending email.';
                                    cls = 'msg-error';
                                }

                                $form.prepend(
                                    $('<div />', {
                                        'class': 'flat-alert ' + cls,
                                        'text' : result
                                    }).append(
                                        $('<a class="close" href="#"><i class="fa fa-close"></i></a>')
                                    )
                                );

                                $form.find(':input').not('.submit').val('');
                            },
                            complete: function (xhr, status, error_thrown) {
                                $form.find('.loading').remove();
                            }
                        });
                    }
                });
            }); // each contactform
        };   // ajax ContactForm

        var swClick = function () {
            function activeLayout () {
                $(".switcher-container" ).on( "click", "a.sw-light", function() {
                    $(this).toggleClass( "active" );
                    $('body').addClass('home-boxed');  
                    $('body').css({'background': '#f6f6f6' });                
                    $('.sw-pattern.pattern').css ({ "top": "100%", "opacity": 1, "z-index": "10"});
                    return false;
                }).on( "click", "a.sw-dark", function() {
                    $('.sw-pattern.pattern').css ({ "top": "98%", "opacity": 0, "z-index": "-1"});
                    $(this).removeClass('active').addClass('active');
                    $('body').removeClass('home-boxed');
                    $('body').css({'background': '#fff' });
                    return false;
                })       
            }

            function activePattern () {
                $('.sw-pattern').on('click', function () {
                    $('.sw-pattern.pattern a').removeClass('current');
                    $(this).addClass('current');
                    $('body').css({'background': 'url("' + $(this).data('image') + '")', 'background-size' : '20px 20px', 'background-repeat': 'repeat' });
                    return false
                })
            }

            activeLayout();
            activePattern();
        } // Switcher Click

        var googleMap = function() {            
            if ( $().gmap3 ) {  
                $(".map").gmap3({
                    map:{
                        options:{
                            zoom: 14,
                            mapTypeId: 'Consulin_style',
                            mapTypeControlOptions: {
                                mapTypeIds: ['Consulin_style', google.maps.MapTypeId.SATELLITE, google.maps.MapTypeId.HYBRID]
                            },
                            scrollwheel: false
                        }
                    },
                    getlatlng:{
                        address:  $('.flat-maps').data('address'),
                        callback: function(results) {
                            if ( !results ) return;
                            $(this).gmap3('get').setCenter(new google.maps.LatLng(results[0].geometry.location.lat(), results[0].geometry.location.lng()));
                            $(this).gmap3({
                                marker:{
                                    latLng:results[0].geometry.location,
                                    options:{
                                        icon: $('.flat-maps').data('images')
                                    }
                                }
                            });
                        }
                    },
                    styledmaptype:{
                        id: "Consulin_style",
                        options:{
                            name: "Consulin Map"
                        },
                        styles:[
                            {
                                "featureType": "administrative",
                                "elementType": "labels.text.fill",
                                "stylers": [
                                    {
                                        "color": "#444444"
                                    }
                                ]
                            },
                            {
                                "featureType": "landscape",
                                "elementType": "all",
                                "stylers": [
                                    {
                                        "color": "#f2f2f2"
                                    }
                                ]
                            },
                            {
                                "featureType": "poi",
                                "elementType": "all",
                                "stylers": [
                                    {
                                        "visibility": "off"
                                    }
                                ]
                            },
                            {
                                "featureType": "road",
                                "elementType": "all",
                                "stylers": [
                                    {
                                        "saturation": -100
                                    },
                                    {
                                        "lightness": 45
                                    }
                                ]
                            },
                            {
                                "featureType": "road.highway",
                                "elementType": "all",
                                "stylers": [
                                    {
                                        "visibility": "simplified"
                                    }
                                ]
                            },
                            {
                                "featureType": "road.arterial",
                                "elementType": "labels.icon",
                                "stylers": [
                                    {
                                        "visibility": "off"
                                    }
                                ]
                            },
                            {
                                "featureType": "transit",
                                "elementType": "all",
                                "stylers": [
                                    {
                                        "visibility": "off"
                                    }
                                ]
                            },
                            {
                                "featureType": "water",
                                "elementType": "all",
                                "stylers": [
                                    {
                                        "color": "#46bcec"
                                    },
                                    {
                                        "visibility": "on"
                                    }
                                ]
                            }
                        ]
                    },  
                });
            }
            $('.map').css( 'height', $('.flat-maps').data('height') );
        };

        var popupGallery = function () {
            $('.flexslider').flexslider({
                animation: "slide",
                controlNav: false,
                slideshowSpeed: 3000
            });
        }; // Popup Gallery

        var goTop = function(){
            var gotop = $('.go-top');
            $(window).on('scroll', function() {
                if ($(this).scrollTop() > 500) {
                    gotop.addClass('show');
                } else {
                    gotop.removeClass('show');
                }
            });
            gotop.on('click', function() {
                $('html, body').animate({ scrollTop: 0}, 800, 'easeInOutExpo');
                return false;
            });
        }; // Go Top

        var retinaLogos = function() {
          var retina = window.devicePixelRatio > 1 ? true : false;

            if(retina) {
                $('.header .logo').find('img').attr( {src:'./images/logo2x.png',width:'202',height:'56'} );   
            }
        }; 

        var removePreloader = function() { 
            $(window).on('load', function() {
                setTimeout(function() {
                    $('.loader').hide(); }, 300           
                ); 
            });      
        }; //remove Preloader


        // ------------------------------
        // Modal
        // ------------------------------
        $("#open-modal").click(function() {
            $('#modal').addClass('show');
            $('#modal-overlay').addClass('show');
        });

        $("#modal-close").click(function() {
            console.log("test close");
            $('#modal').removeClass('show');
            $('#modal-overlay').removeClass('show');
        });

        $("#modal-overlay").click(function() {
            console.log("test close");
            $('#modal').removeClass('show');
            $('#modal-overlay').removeClass('show');
        });


    // Dom Ready
    $(function() {
        responsiveMenu();
        headerFixed();
        searchButton();
        slideTeam();
        slideBrand();
        slideTestimonial();
        slideTeam_v2();
        slideTestimonial_v2();
        accordionToggle();
        portfolioIsotope();
        ajaxSubscribe.eventLoad();
        ajaxContactForm();
        counterAbout();
        progressBar();
        detectViewport();
        parallax();
        swClick();
        googleMap();
        popupGallery();
        goTop();
        retinaLogos();
        removePreloader();
    });

})(jQuery);